<html>

<head>

  <title>SVL</title>

  <meta http-equiv="content-type" content="text/html;charset=utf-8" />

  <style type="text/css">

    body
    {
      font-family: sans-serif;
      font-size: 8pt;
    }

    textarea
    {
      overflow-x: hidden;
      overflow-y: scroll;
      border: 1px solid black;
      padding: 2px 3px;
      background: black;
      color: white;
      font-family: monospace;
      font-size: 18pt;
      font-weight: normal;
    }

    #control
    {
      vertical-align: top;
      margin-top: 1px;
    }

    input[type=text]
    {
      background: gold;
      border: 0;
      font-size: 8pt;
      margin-bottom: 2px;
      margin-right: 2px;
      padding: 0 3px;
      width: 33px;
    }

    div,
    label
    {
      display: inline-block;
    }

    label
    {
      width: 80px;
      text-align: right;
      margin: 0 5px;
    }

    label.event-type
    {
      text-align: left;
      width: 65px;
      margin-left: 20px;
    }

    label.modifier,
    label.character,
    label.which,
    label.keycode,
    label.asc
    {
      text-align: center;
      margin: 0 2px 0 0;
    }

    label.modifier,
    input[type=text].modifier
    {
      width: 145px;
    }

    label.character,
    input[type=text].character
    {
      width: 95px;
    }

    label.which,
    input[type=text].which,
    label.keycode,
    input[type=text].keycode,
    label.asc,
    input[type=text].asc
    {
      width: 55px;
    }

  </style>

  <script type="text/javascript">
  <!--



    var IE = document.all;

    /*
       <http://unixpapa.com/js/testkey.html>
       <http://www.ascii-code.com/>
    */

    var special_key =
    {
      /*
         Caracteres com o mesmo codigo ASCII no Firefox
            -  --  insert
            '  --  cursor right
            "  --  page down
            .  --  delete
      */
        8 : '<back space>',
        9 : '<tab>',
       13 : '<carriage return>',
       19 : '<pause>',
       20 : '<caps lock>',
       27 : '<escape>',
       32 : '<space>',
       33 : '<page up>',
       34 : '<page down>',
       35 : '<end>',
       36 : '<home>',
       37 : '<cursor left>',
       38 : '<cursor up>',
       39 : '<cursor right>',
       40 : '<cursor down>',
       45 : '<insert>',
       46 : '<delete>',
      144 : '<num lock>',
      145 : '<scroll lock>',
    };

    var function_key =
    {
      112 : '<f1>'  , // p
      113 : '<f2>'  , // q
      114 : '<f3>'  , // r
      115 : '<f4>'  , // s
      116 : '<f5>'  , // t
      117 : '<f6>'  , // u
      118 : '<f7>'  , // v
      119 : '<f8>'  , // w
      120 : '<f9>'  , // x
      121 : '<f10>' , // y
      122 : '<f11>' , // z
      123 : '<f12>' ,
    };

    var prompt, cont, tab, eol;
 // prompt = '❓'; // 2753
    prompt = '?'; // 2753
 // cont   = '➜'; // 279c
    cont   = '→'; // 2192
 // tab    = '⥤'; // 2964
    tab    = '⇥'; // 21e5
 // eol    = '↵'; // 21b5
    eol    = '↲'; // 21b2



    function $(elid)
    {
      return document.getElementById(elid);
    }



    function getSelectionStatus(el)
    {
      var start = end = line = col = lines = cols = 0;
      var normalizedValue, range, textInputRange, len, endRange, lines_set;
      if ( typeof el.selectionStart == 'number' && typeof el.selectionEnd == 'number' )
      {
        start = el.selectionStart;
        end   = el.selectionEnd;
      }
      else
      {
        range = document.selection.createRange();
        if ( range && range.parentElement() == el )
        {
          len = el.value.length;
          normalizedValue = el.value.replace(/\r\n/g, '\n');
          // Create a working TextRange that lives only in the input
          textInputRange = el.createTextRange();
          textInputRange.moveToBookmark(range.getBookmark());
          // Check if the start and end of the selection are at the very end
          // of the input, since moveStart/moveEnd doesn't return what we want
          // in those cases
          endRange = el.createTextRange();
          endRange.collapse(false);
          if ( textInputRange.compareEndPoints('StartToEnd', endRange) > -1 )
          {
              start = end = len;
          }
          else
          {
            start  = -textInputRange.moveStart('character', -len);
            start += normalizedValue.slice(0, start).split('\n').length - 1;
            if ( textInputRange.compareEndPoints('EndToEnd', endRange) > -1 )
            {
              end  = len;
            }
            else
            {
              end  = -textInputRange.moveEnd('character', -len);
              end += normalizedValue.slice(0, end).split('\n').length - 1;
            }
          }
        }
      }
      set1  = el.value.split('\n');
      lines = set1.length;
      set2  = el.value.substr(0,start).split('\n');
      line  = set2.length - 1;
      col   = set2[line].length;
      cols  = set1[line].length;
      return {
               'start' : start,
               'end'   : end,
               'line'  : line,
               'col'   : col,
               'lines' : lines,
               'cols'  : cols
             };
    }



    function set_cursor_pos(ctrl, pos)
    {
      if (ctrl.setSelectionRange)
      {
        ctrl.focus();
        ctrl.setSelectionRange(pos,pos);
      }
      else
      {
        if (ctrl.createTextRange)
        {
          range = ctrl.createTextRange();
          range.collapse(true);
          range.moveEnd('character', pos);
          range.moveStart('character', pos);
          range.select();
        }
      }
    }



    function show(data)
    {
      for(field in data) $(field).value = data[field];
    }



    function readKey(type,e)
    {

      // <http://unixpapa.com/js/testkey.html>
      // <http://www.ascii-code.com/>

      var eparts = [ 'modifier', 'character', 'which', 'keycode', 'asc' ];
      var key    = new Array();

      key['modifier'] = '';
      if ( e.ctrlKey  ) key['modifier'] += '<control>';
      if ( e.altKey   ) key['modifier'] += '<alternate>';
      if ( e.shiftKey ) key['modifier'] += '<shift>';
      if ( e.metaKey  ) key['modifier'] += '<meta>';

      key['which'  ] = e.which;
      key['keycode'] = e.keyCode;
      key['asc'    ] = key['keycode']==0 ? key['which'] : key['keycode'];

      key['character'] = String.fromCharCode(key['asc']);
      if ( special_key[key['asc']] !== undefined ) key['character'] = special_key[key['asc']];
      if ( key['keycode']!=0 && function_key[key['asc']] !== undefined ) key['character'] = function_key[key['asc']];

      for (epart in eparts) $(type+'-'+eparts[epart]).value = key[eparts[epart]];
   // $('lastKey').value = $('console').lastKey;

    }



    function interpret(el)
    {

      var blast, last;
      var asc, chr;
      var col, cols;

      var data = getSelectionStatus(el);

      blast = el.value.substr(-2,1);
      last  = el.value.substr(-1,1);
      asc   = $('keypress-asc').value;
      chr   = $('keypress-character').value;
      col   = data['col'];
      cols  = data['cols'];
      pos   = data['start'];

      if (last=='\n') last = '<cr>';

      data['blast'] = blast;
      data['last' ] =  last;

      if (asc==13 && last=='<cr>') el.value = el.value.substr(0,el.value.length-1)+eol+'\n'+prompt+' ';
      if (col==40 && chr!='<cursor left>' && chr!='<cursor right>' && chr!='<back space>') el.value += cont+'\n';

/*

      if (col== 2 && chr=='<cursor left>') el.value += eol+'\n';
      if (col== 2 && chr=='<back space>' ) el.value += eol+'\n';

      if (col==cols && chr!='<cursor left>' && chr!='<cursor right>') el.value += eol+'\n';
      if (col==cols+1 && chr=='<cursor left>' ) set_cursor_pos($('console'), pos-2);
      if (col==cols   && chr=='<cursor right>') set_cursor_pos($('console'), pos+2);
      $('console').scrollTop = $('console').scrollHeight - $('console').clientHeight;

*/

      show(data);

    }



  //-->
  </script>

</head>

<body>

  <form>

    <textarea
     id          = "console"
     rows        = "20"
     cols        = "41"
     onkeypress  = "readKey('keypress' ,event); interpret(this);"
     onkeydown   = "readKey('keydown'  ,event); interpret(this);"
     onkeyup     = "readKey('keyup'    ,event); interpret(this);"
     ontextinput = "readKey('textinput',event); interpret(this);"
     onclick     = "interpret(this);"
    >SVG Logo 0.3
Bem-vindo ao Logo

? </textarea>
    <div id="control">
      <label>Selection Start</label><input type="text" id="start"   readonly /><br />
      <label>Selection End  </label><input type="text" id="end"     readonly /><br />
      <label>Line           </label><input type="text" id="line"    readonly /><br />
      <label>Column         </label><input type="text" id="col"     readonly /><br />
      <label>Lines          </label><input type="text" id="lines"   readonly /><br />
      <label>Columns        </label><input type="text" id="cols"    readonly /><br />
      <label>Penúltimo      </label><input type="text" id="blast"   readonly /><br />
      <label>Último         </label><input type="text" id="last"    readonly /><br />
      <label>lastKey        </label><input type="text" id="lastKey" readonly /><br />
      <label class="event-type">           </label><label class="modifier">Modifier</label                               ><label class="character">Character</label                               ><label class="which">Which</label                               ><label class="keycode">KeyCode</label                               ><label class="asc">ASC</label><br />
      <label class="event-type">onKeyPress </label><input class="modifier" type="text" id="keypress-modifier"  readonly /><input class="character" type="text" id="keypress-character"  readonly /><input class="which" type="text" id="keypress-which"  readonly /><input class="keycode" type="text" id="keypress-keycode"  readonly /><input class="asc" type="text" id="keypress-asc"  readonly /><br />
      <label class="event-type">onKeyDown  </label><input class="modifier" type="text" id="keydown-modifier"   readonly /><input class="character" type="text" id="keydown-character"   readonly /><input class="which" type="text" id="keydown-which"   readonly /><input class="keycode" type="text" id="keydown-keycode"   readonly /><input class="asc" type="text" id="keydown-asc"   readonly /><br />
      <label class="event-type">onKeyUp    </label><input class="modifier" type="text" id="keyup-modifier"     readonly /><input class="character" type="text" id="keyup-character"     readonly /><input class="which" type="text" id="keyup-which"     readonly /><input class="keycode" type="text" id="keyup-keycode"     readonly /><input class="asc" type="text" id="keyup-asc"     readonly /><br />
      <label class="event-type">onTextInput</label><input class="modifier" type="text" id="textinput-modifier" readonly /><input class="character" type="text" id="textinput-character" readonly /><input class="which" type="text" id="textinput-which" readonly /><input class="keycode" type="text" id="textinput-keycode" readonly /><input class="asc" type="text" id="textinput-asc" readonly /><br />
    </div>

  </form>

</body>

</html>
